
typedef unsigned char rtems_unsigned8;

#include "mc68hc901.h"

/*
 * prototypes
 */
void outbyte( int ch );
int inbyte( void );


/*
 * Device-specific routines
 */

static void mc68hc901_out_char( int ch )
{
  MC68HC901 *mc68hc901 = (MC68HC901 *)0x30000000;
  
  while ((mc68hc901->TSR & MC68HC901_TSR_BE) == 0)
    continue;

  mc68hc901->UDR = ch;
  mc68hc901->TSR = MC68HC901_TSR_HL_HIGH | MC68HC901_TSR_TE;
}


static int mc68hc901_in_char( void )
{
  MC68HC901 *mc68hc901 = (MC68HC901 *)0x30000000;
  

  while ((mc68hc901->RSR & MC68HC901_RSR_BF) == 0)
    continue;
		
  return mc68hc901->UDR;;
}


/*
 * Exported functions
 */
void outbyte( int ch )
{
  mc68hc901_out_char( ch );
}

int inbyte( void )
{
  int ch;
  
  ch = mc68hc901_in_char();
  
  mc68hc901_out_char( ch );
  
  if (ch == '\r')
  {
    mc68hc901_out_char( '\n' );
  }
  else if (ch == '\n' )
  {
    mc68hc901_out_char( '\r' );
  } 
  
  
  return ch;
}
